> ## Documentation Index
> Fetch the complete documentation index at: https://developers.myhero.so/llms.txt
> Use this file to discover all available pages before exploring further.

# Create tables from a spreadsheet

> Parses a CSV, TSV, or XLSX file (provided as a base64-encoded string in `csvData`) and creates one table per sheet.

Column types are inferred from the data.

Returns a single Table object for single-sheet uploads, or an array for multi-sheet XLSX files.



## OpenAPI

````yaml post /table/csv-upload
openapi: 3.1.0
info:
  title: HERO API
  version: current
  description: |-
    The HERO REST API.

    See https://developers.myhero.so for the rendered docs.
servers:
  - url: https://app.myhero.so
security: []
paths:
  /table/csv-upload:
    post:
      tags:
        - Tables
      summary: Create tables from a spreadsheet
      description: >-
        Parses a CSV, TSV, or XLSX file (provided as a base64-encoded string in
        `csvData`) and creates one table per sheet.


        Column types are inferred from the data.


        Returns a single Table object for single-sheet uploads, or an array for
        multi-sheet XLSX files.
      operationId: createTableFromCSV
      requestBody:
        content:
          application/json:
            schema:
              type: object
              properties:
                projectId:
                  type: string
                  minLength: 1
                csvData:
                  type: string
                  minLength: 1
                name:
                  type: string
                format:
                  type: string
                  enum:
                    - csv
                    - tsv
                    - xlsx
              required:
                - projectId
                - csvData
      responses:
        '200':
          description: 200 response
          content:
            application/json:
              schema:
                type: object
                properties:
                  data:
                    anyOf:
                      - type: object
                        properties:
                          _id:
                            type: string
                          originId:
                            type: string
                          name:
                            type: string
                          slug:
                            type: string
                          description:
                            type: string
                          rows:
                            type: array
                            items:
                              type: string
                          columns:
                            type: array
                            items:
                              type: string
                          isStatic:
                            type: boolean
                            example: false
                          icon:
                            type: object
                            properties:
                              name:
                                type: string
                              color:
                                type: string
                            required:
                              - name
                              - color
                          ownerId:
                            type: string
                          projectId:
                            type: string
                          workspaceId:
                            type: string
                          createdAt:
                            type: number
                          updatedAt:
                            type: number
                          isDeleted:
                            type: boolean
                            example: false
                        required:
                          - _id
                          - name
                          - slug
                          - rows
                          - columns
                          - isStatic
                          - ownerId
                          - projectId
                          - workspaceId
                          - createdAt
                          - updatedAt
                      - type: array
                        items:
                          type: object
                          properties:
                            _id:
                              type: string
                            originId:
                              type: string
                            name:
                              type: string
                            slug:
                              type: string
                            description:
                              type: string
                            rows:
                              type: array
                              items:
                                type: string
                            columns:
                              type: array
                              items:
                                type: string
                            isStatic:
                              type: boolean
                              example: false
                            icon:
                              type: object
                              properties:
                                name:
                                  type: string
                                color:
                                  type: string
                              required:
                                - name
                                - color
                            ownerId:
                              type: string
                            projectId:
                              type: string
                            workspaceId:
                              type: string
                            createdAt:
                              type: number
                            updatedAt:
                              type: number
                            isDeleted:
                              type: boolean
                              example: false
                          required:
                            - _id
                            - name
                            - slug
                            - rows
                            - columns
                            - isStatic
                            - ownerId
                            - projectId
                            - workspaceId
                            - createdAt
                            - updatedAt
                required:
                  - data
        '400':
          description: 400 response
          content:
            application/json:
              schema:
                type: object
                properties:
                  error:
                    type: string
                    description: |-
                      Error class name (e.g.

                      ValidationError, NotFound)
                  message:
                    type: string
                    description: Human-readable error message
                  details:
                    type: array
                    items: {}
                required:
                  - error
                  - message
        '403':
          description: 403 response
          content:
            application/json:
              schema:
                type: object
                properties:
                  error:
                    type: string
                    description: |-
                      Error class name (e.g.

                      ValidationError, NotFound)
                  message:
                    type: string
                    description: Human-readable error message
                  details:
                    type: array
                    items: {}
                required:
                  - error
                  - message
      security:
        - bearerAuth: []
components:
  securitySchemes:
    bearerAuth:
      type: http
      scheme: bearer
      description: HERO personal access token

````